/*
 * mkClasses 1.0
 * -------------
 *
 * Please see the web pages for releases and documentation.
 *
 * Author: Michael Kraus
 *         mailto:mmg_kraus@csi.com
 *         http://ourworld.compuserve.com/homepages/mmg_kraus
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted.
 * The author makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without express
 * or implied warranty.  By use of this software the user agrees to
 * indemnify and hold harmless the author from any claims or
 * liability for loss arising out of such use.
 *
 */

/* required to built a dll using stubs. should be a compiler option */
/* #define USE_TCL_STUBS */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <tcl.h>

#ifndef TRUE
#  define TRUE  1
#  define FALSE 0
#endif

/* copied from sun's example.c */
#ifdef __WIN32__
#if defined(__WIN32__)
#   define WIN32_LEAN_AND_MEAN
#   include <windows.h>
#   undef WIN32_LEAN_AND_MEAN
#   if defined(_MSC_VER)
#       define EXPORT(a,b) __declspec(dllexport) a b
#       define DllEntryPoint DllMain
#   else
#       if defined(__BORLANDC__)
#           define EXPORT(a,b) a _export b
#       else
#           define EXPORT(a,b) a b
#       endif
#   endif
#else
#   define EXPORT(a,b) a b
#endif

EXTERN EXPORT(int,Mkclasses_Init) _ANSI_ARGS_((Tcl_Interp *interp));
EXTERN EXPORT(int,Mkclasses_SafeInit) _ANSI_ARGS_((Tcl_Interp *interp));
BOOL APIENTRY DllEntryPoint(HINSTANCE hInst, DWORD reason, LPVOID reserved)
{
    return TRUE;
}
#endif

/* mkClasses version number */
#define _VERSION           "1.0"

/* some acronyms for popular Tcl_xxx functions */
#define _NSO(pcText)       Tcl_NewStringObj( pcText, -1 )
#define _SSO(pO,pcText)    Tcl_SetStringObj( pO, pcText, -1 )
#define _GSO(pO)           Tcl_GetStringFromObj( pO, NULL )

#define _NIO(iVal)         Tcl_NewIntObj( iVal )
#define _SIO(pO,iVal)      Tcl_SetIntObj( pO, iVal )
#define _GIO(pO,piVal)     Tcl_GetIntFromObj( pI, pO, piVal )

#define _NBO(bVal)         Tcl_NewBooleanObj( bVal )
#define _SBO(pO,bVal)      Tcl_SetBooleanObj( pO, bVal )
#define _GBO(pO,pbVal)     Tcl_GetBooleanFromObj( pI, pO, pbVal )

#define _NDO(fVal)         Tcl_NewDoubleObj( fVal )
#define _SDO(pO,fVal)      Tcl_SetDoubleObj( pO, fVal )
#define _GDO(pO,pfVal)     Tcl_GetDoubleFromObj( pI, pO, pfVal )

#define _LOAL(pO,pNewO)    Tcl_ListObjAppendList( pI, pO, pNewO )
#define _LOAE(pO,pNewO)    Tcl_ListObjAppendElement( pI, pO, pNewO )
#define _LOGL(pO,piLen)    Tcl_ListObjLength( pI, pO, piLen )
#define _LOGI(pO,iI,poE)   Tcl_ListObjIndex( pI, pO, iI, poE )
#define _LOGE(pO,piC,ppV)  Tcl_ListObjGetElements( pI, pO, piC, ppV )
#define _LORE(pO,iPos,poE) Tcl_ListObjReplace( pI, pO, iPos, 1, 1, poE )
#define _LODE(pO,iPos)     Tcl_ListObjReplace( pI, pO, iPos, 1, 0, NULL )
#define _LOIE(pO,iPos,poE) Tcl_ListObjReplace( pI, pO, iPos, 0, 1, poE )
#define _LOIR(pO,iPos,iC,poE) Tcl_ListObjReplace( pI, pO, iPos, 0, iC, poE )
#define _LORR(pO,iP1,iP2,iC,ppV)  Tcl_ListObjReplace( pI, pO, iP1, (iP2)-(iP1)+1, iC, ppV )

#define _OSV(po1,po2,poV)  Tcl_ObjSetVar2( pI, po1, po2, poV, TCL_LEAVE_ERR_MSG )
#define _OGV(po1,po2)      Tcl_ObjGetVar2( pI, po1, po2, TCL_LEAVE_ERR_MSG )
#define _OUV(po1,po2)      Tcl_UnsetVar2( pI, _GSO(po1), (po2==NULL)?NULL:_GSO(po2), TCL_LEAVE_ERR_MSG )
#define _OSVG(po1,po2,poV) Tcl_ObjSetVar2( pI, po1, po2, poV, TCL_GLOBAL_ONLY | TCL_LEAVE_ERR_MSG )
#define _OGVG(po1,po2)     Tcl_ObjGetVar2( pI, po1, po2, TCL_GLOBAL_ONLY | TCL_LEAVE_ERR_MSG )
#define _OUVG(po1,po2)     Tcl_UnsetVar2( pI, _GSO(po1), (po2==NULL)?NULL:_GSO(po2), TCL_GLOBAL_ONLY )

#define _NOB               Tcl_NewObj()
#define _DOB               Tcl_DuplicateObj
#define _SOB(pO)           Tcl_IsShared( pO )? Tcl_DuplicateObj( pO ):pO
#define _ASO               Tcl_AppendStringsToObj

#define _DRC               Tcl_DecrRefCount
#define _IRC               Tcl_IncrRefCount

#define _GOR               Tcl_GetObjResult( pI )
#define _SOR(pO)           Tcl_SetObjResult( pI, pO )
#define _ROR               Tcl_ResetResult( pI )

#define _HACE              Tcl_CreateHashEntry
#define _HADE              Tcl_DeleteHashEntry
#define _HASV              Tcl_SetHashValue
#define _HAFE              Tcl_FindHashEntry
#define _HAGV              Tcl_GetHashValue
#define _HAGK              Tcl_GetHashKey

#define _HAFESV(phH,pcK,psD,piN) _HASV( _HACE( phH, pcK, piN ), psD )
#define _HASCAN(phH,peE,psS)     peE = Tcl_FirstHashEntry( phH, psS ); peE != NULL; peE = Tcl_NextHashEntry( psS )

#define _GIFO(pO,pA,pcTxt,piRes) Tcl_GetIndexFromObj( pI, pO, pA, pcTxt, 0, piRes )
#define _WNA(objc,pcText)        ( Tcl_WrongNumArgs( pI, objc, objv, pcText ), TCL_ERROR )
#define _CHECKTHIS(poThis)       if( poThis == NULL ) return _MkcError( pI, "Not in an object" )

/* my very own exception handling */
#define try( Expr, Excep )       { if( Expr != TCL_OK ) throw Excep; }
#define throw                    goto
#define catch

/* _MkcInfo
   struct for each created interpreter. holds a table of all defined classes
   and of all created objects. the entries of both tables point to class
   structs. if an object's method is executed, poThis contains the name of
   the object, otherwise NULL.
*/
typedef struct _MkcInfo {
  Tcl_HashTable    hClasses;
  Tcl_HashTable    hObjects;
  Tcl_Obj         *poThis;
} _MkcInfo;

/* _MkcClass
   struct for each defined class. holds a table of all superclasses and a
   table of all members, own and inherited ones. if one of these members
   point back to a different class than this one, it is an inherited member.
   the char array ppcMembers contains the names of all members for later
   use with Tcl_GetIndexFromObj().
*/
typedef struct _MkcClass {
  Tcl_Obj       *poClass;
  Tcl_HashTable  hInherit;
  Tcl_HashTable  hMembers;
  char         **ppcMembers;
  _MkcInfo      *psInfo;
} _MkcClass;

/* _MkcMember
   struct for each member of a class. holds member name, argument list
   and body. points backward to its class struct. if iArgs is true,
   the "args" keyword has been used in the argument list.
*/
typedef struct _MkcMember {
  Tcl_Obj       *poMember;
  Tcl_Obj       *poArgs;
  Tcl_Obj       *poBody;
  int            iArgs;
  _MkcClass     *psClass;
} _MkcMember;

/* the function prototypes. */
int  Mkclasses_Init( Tcl_Interp * );
int  Mkclasses_SafeInit( Tcl_Interp * );
void Mkclasses_Exit( ClientData, Tcl_Interp * );

int Mkc_ThisCmd     ( ClientData, Tcl_Interp *, int, Tcl_Obj *CONST[] );
int Mkc_ExecCmd     ( ClientData, Tcl_Interp *, int, Tcl_Obj *CONST[] );

int Mkc_ClassCmd    ( ClientData, Tcl_Interp *, int, Tcl_Obj *CONST[] );
int Mkc_ClassDelCmd ( ClientData, Tcl_Interp *, int, Tcl_Obj *CONST[] );
int Mkc_MemberCmd   ( ClientData, Tcl_Interp *, int, Tcl_Obj *CONST[] );
int Mkc_MemberDelCmd( ClientData, Tcl_Interp *, int, Tcl_Obj *CONST[] );
int Mkc_ConstrCmd   ( ClientData, Tcl_Interp *, int, Tcl_Obj *CONST[] );
int Mkc_DestrCmd    ( ClientData, Tcl_Interp *, int, Tcl_Obj *CONST[] );

int Mkc_MyCmd       ( ClientData, Tcl_Interp *, int, Tcl_Obj *CONST[] );
int Mkc_UnmyCmd     ( ClientData, Tcl_Interp *, int, Tcl_Obj *CONST[] );
int Mkc_MineCmd     ( ClientData, Tcl_Interp *, int, Tcl_Obj *CONST[] );
int Mkc_IsmineCmd   ( ClientData, Tcl_Interp *, int, Tcl_Obj *CONST[] );

int Mkc_OurCmd      ( ClientData, Tcl_Interp *, int, Tcl_Obj *CONST[] );
int Mkc_UnourCmd    ( ClientData, Tcl_Interp *, int, Tcl_Obj *CONST[] );
int Mkc_OursCmd     ( ClientData, Tcl_Interp *, int, Tcl_Obj *CONST[] );
int Mkc_IsoursCmd   ( ClientData, Tcl_Interp *, int, Tcl_Obj *CONST[] );

int Mkc_CinfoCmd    ( ClientData, Tcl_Interp *, int, Tcl_Obj *CONST[] );
int Mkc_ThrowCmd    ( ClientData, Tcl_Interp *, int, Tcl_Obj *CONST[] );

int Mkc_MyincrCmd   ( ClientData, Tcl_Interp *, int, Tcl_Obj *CONST[] );
int Mkc_MyindexCmd  ( ClientData, Tcl_Interp *, int, Tcl_Obj *CONST[] );
int Mkc_MylengthCmd ( ClientData, Tcl_Interp *, int, Tcl_Obj *CONST[] );
int Mkc_MysearchCmd ( ClientData, Tcl_Interp *, int, Tcl_Obj *CONST[] );
int Mkc_MyconcatCmd ( ClientData, Tcl_Interp *, int, Tcl_Obj *CONST[] );
int Mkc_MyappendCmd ( ClientData, Tcl_Interp *, int, Tcl_Obj *CONST[] );
int Mkc_MyrangeCmd  ( ClientData, Tcl_Interp *, int, Tcl_Obj *CONST[] );
int Mkc_MydeleteCmd ( ClientData, Tcl_Interp *, int, Tcl_Obj *CONST[] );
int Mkc_MyinsertCmd ( ClientData, Tcl_Interp *, int, Tcl_Obj *CONST[] );
int Mkc_MyreplaceCmd( ClientData, Tcl_Interp *, int, Tcl_Obj *CONST[] );
int Mkc_MyassignCmd ( ClientData, Tcl_Interp *, int, Tcl_Obj *CONST[] );
int Mkc_MylistCmd   ( ClientData, Tcl_Interp *, int, Tcl_Obj *CONST[] );

static int  _MkcError       ( Tcl_Interp *, char *, ... );
static int  _MkcGetEntry    ( Tcl_Interp *, Tcl_HashTable *, char *, Tcl_HashEntry **, char * );
static int  _MkcGetData     ( Tcl_Interp *, Tcl_HashTable *, char *, void **, char * );
static int  _MkcSplitName   ( Tcl_Interp *, Tcl_Obj *, int *, Tcl_Obj ***, int, char * );
static int  _MkcObjectsExist( Tcl_Interp *, _MkcClass * );
static int  _MkcGetValue    ( Tcl_Interp *, Tcl_Obj *, Tcl_Obj *, Tcl_Obj **, int );
static int  _MkcBuildNames  ( Tcl_Interp *, _MkcClass * );
static int  _MkcCreateMember( Tcl_Interp *, _MkcClass *, Tcl_Obj *, Tcl_Obj *, Tcl_Obj * );
static void _MkcDeleteMember( _MkcMember *psMember );
static void _MkcDeleteClass ( _MkcClass *psClass );

/* _MkcError
   creates a formatted object result string and always returns TCL_ERROR.
   like with printf(), at least a format string must be provided.
   in addition, the format string may contain "%O" for Tcl_Obj* types.
*/
static int _MkcError( Tcl_Interp *pI, char *pcFormat, ... )
{
  int     i;
  char  **args, *pcRun, pcMsg[2000], pcFmt[2000];
  va_list marker;

  if( pI == NULL || pcFormat == NULL )
    return TCL_ERROR;

  va_start( marker, pcFormat );
  args = (char**)marker;

  strcpy( pcFmt, pcFormat );

  for( i = 0, pcRun = pcFmt; *pcRun; pcRun++ )
  {
    if( *pcRun != '%' ) continue;

    pcRun++;
    if( *pcRun == 'O' )
    {
      *pcRun = 's';
      args[i] = _GSO( (Tcl_Obj*)args[i] );
	  i++;
    }
  }

  vsprintf( pcMsg, pcFmt, marker );
  _SSO( _GOR, pcMsg );

  return TCL_ERROR;
}

/* _MkcGetIndex
   utility function. transforms an index like "end-4" into an integer.
   iLen is the length of the list to which the index refers. used for
   myreplace, myindex, mydelete, myinsert.
*/
int _MkcGetIndex( Tcl_Interp *pI, Tcl_Obj *poObj, int iLen, int *piIndex )
{
  int iIndex;

  if( _GIO( poObj, &iIndex ) == TCL_OK )
    *piIndex = iIndex;
  else if( ! strcmp( _GSO( poObj ), "end" ) || ! strcmp( _GSO( poObj ), "end-0" ) )
    *piIndex = iLen-1;
  else if( ! strncmp( _GSO( poObj ), "end-", 4 ) && ( iIndex = atoi( _GSO( poObj ) + 4 ) ) != 0 )
    *piIndex = iLen-iIndex-1;
  else
    return _MkcError( pI, "bad index '%O': must be integer or end?-integer?", poObj );

  _ROR;
  return TCL_OK;
}

/* _MkcGetEntry
   searches the entry for pcKey in the given hash table, sets ppeEntry and
   returns TCL_OK. if the key could not be found, TCL_ERROR is returned.
*/
static int _MkcGetEntry( Tcl_Interp *pI, Tcl_HashTable *phTable, char *pcKey, Tcl_HashEntry **ppeEntry, char *pcText )
{
  *ppeEntry = _HAFE( phTable, pcKey );

  if( *ppeEntry == NULL )
    return _MkcError( pI, "%s '%s' does not exist", pcText, pcKey );

  return TCL_OK;
}

/* _MkcGetData
   searches the entry for pcKey in the given hash table, sets ppsData
   to the entry's hash value and returns TCL_OK. if the key could not be
   found, TCL_ERROR is returned.
*/
static int _MkcGetData( Tcl_Interp *pI, Tcl_HashTable *phTable, char *pcKey, void **ppsData, char *pcText )
{
  static Tcl_HashEntry *peEntry;

  if( ( peEntry = _HAFE( phTable, pcKey ) ) == NULL )
  {
    if( pcText != NULL )
      return _MkcError( pI, "%s '%s' does not exist", pcText, pcKey );
    else
      return TCL_ERROR;
  }

  *ppsData  = _HAGV( peEntry );

  return TCL_OK;
}

/* _MkcCompareInt
   used for the qsort function in mydelete. compares to integers.
   see documentation of qsort().
*/
int _MkcCompareInt( const void *piInt1, const void *piInt2 )
{
  if( *(int*)piInt1 < *(int*)piInt2 )
    return -1;
  if( *(int*)piInt1 > *(int*)piInt2 )
    return 1;
  else
    return 0;
}

/* _MkcSplitName
   copies poName into an own object and replaces all ':' with blanks. splits
   the object and returns element count and vector. leaves poName unchanged.
*/
static int _MkcSplitName( Tcl_Interp *pI, Tcl_Obj *poName, int *piObjc, Tcl_Obj ***pppoObjv, int iCount, char *pcText )
{
  char *pcColon;
  static Tcl_Obj *poBuf = NULL;

  if( poBuf == NULL )
    poBuf = _NOB;

  _SSO( poBuf, _GSO( poName ) );

  while( ( pcColon = strchr( _GSO( poBuf ), ':' ) ) != NULL )
    *pcColon = ' ';

  try( _LOGE( poBuf, piObjc, pppoObjv ), eError );

  if( pcText != NULL && *piObjc != iCount )
    throw eBadFormat;

  return TCL_OK;

  catch eError:
    return _MkcError( pI, "Could not split up '%O'", poName );
  catch eBadFormat:
    return _MkcError( pI, "Bad format '%O'. Should be '%s'", poName, pcText );
}

/* _MkcObjectsExist
   checks for the given class if any objects of it exist. also checks if
   this class acts as a superclass for any other class. if either is true,
   an error is returned.
*/
static int _MkcObjectsExist( Tcl_Interp *pI, _MkcClass *psClass )
{
  Tcl_HashEntry *peObject, *peClass;
  Tcl_HashSearch ssObject, ssClass;

  for( _HASCAN( &(psClass->psInfo->hObjects), peObject, &ssObject ) )
    if( (_MkcClass*)_HAGV( peObject ) == psClass )
      throw eObjectsExist;

  for( _HASCAN( &(psClass->psInfo->hClasses), peClass, &ssClass ) )
    if( _HAFE( &(((_MkcClass*)_HAGV( peClass ))->hInherit), _GSO( psClass->poClass ) ) != NULL )
      throw eIsSuperclass;

  return TCL_OK;

  catch eObjectsExist:
    return _MkcError( pI, "Objects exist for class '%O'", psClass->poClass );
  catch eIsSuperclass:
    return _MkcError( pI, "Class '%O' is used as a superclass", psClass->poClass );
}

/* _MkcGetValue
   retrieves the value of a private variable. poThis contains the object name
   and poVar the variable name. if the variable exists, ppoValue points to its
   value. if it does not exist and bForce is true, the variable is created.
*/
static int _MkcGetValue( Tcl_Interp *pI, Tcl_Obj *poThis, Tcl_Obj *poVar, Tcl_Obj **ppoValue, int bForce )
{
  *ppoValue = _OGVG( poThis, poVar );

  if( *ppoValue == NULL )
  {
    if( ! bForce )
      return _MkcError( pI, "No such private variable '%O'", poVar );

    *ppoValue = _NSO( "" );
    _OSVG( poThis, poVar, *ppoValue );
  }

  return TCL_OK;
}

/* _MkcBuildNames
   rebuilds the char array ppcMembers in a class struct. for each member
   in the hMembers hash table an element in ppcMembers is created, pointing
   to the name of the member. So, if a member name is abbreviated, it can
   still be found by using Tcl_GetIndexFromObj() in Mkc_ExecCmd().
*/
static int _MkcBuildNames( Tcl_Interp *pI, _MkcClass *psClass )
{
  int             i;
  char           *pcMember;
  Tcl_HashEntry  *peMember;
  Tcl_HashSearch  ssMember;

  if( psClass->ppcMembers != NULL )
    ckfree( (char*)psClass->ppcMembers );

  for( i = 0, _HASCAN( &(psClass->hMembers), peMember, &ssMember ), i++ );

  psClass->ppcMembers = (char **)ckalloc( (i+1) * sizeof(char **) );

  for( i = 0, _HASCAN( &(psClass->hMembers), peMember, &ssMember ), i++ )
  {
    pcMember = _HAGK( &(psClass->hMembers), peMember );
    psClass->ppcMembers[i] = pcMember;
  }

  psClass->ppcMembers[i] = NULL;

  return TCL_OK;
}

/* _MkcCreateMember
   for class psClass a member is created. if the member name exists and its
   class is different than psClass the member is overwritten. a member struct
   is allocated and filled. checks if the last argument in the argument list
   is "args". checks if the member name is "unknown" in which case there must
   be exactly two arguments for this member function.
*/
static int _MkcCreateMember( Tcl_Interp *pI, _MkcClass *psClass, Tcl_Obj *poMember, Tcl_Obj *poArgs, Tcl_Obj *poBody )
{
  int            bNew, iObjc, iArgs;
  Tcl_Obj       *poName, **ppoObjv;
  Tcl_HashEntry *peMember;
  _MkcMember    *psMember;

  peMember = _HACE( &(psClass->hMembers), _GSO( poMember ), &bNew );
  if( ! bNew )
  {
    psMember = (_MkcMember*)_HAGV( peMember );
    if( psMember->psClass == psClass )
      throw eMemberExists;
  }

  _LOGE( poArgs, &iObjc, &ppoObjv );

  if( ! strcmp( _GSO( poMember ), "unknown" ) && iObjc != 2 )
    throw eBadUnknownArgs;

  poName = _DOB( psClass->poClass ); _ASO( poName, ":", _GSO( poMember ), NULL );
  iArgs = ( iObjc && ! strcmp( _GSO( ppoObjv[iObjc-1] ), "args" ) );

  psMember = (_MkcMember*)ckalloc( sizeof(_MkcMember) );
  psMember->poMember = poName; _IRC( psMember->poMember );
  psMember->poArgs   = poArgs; _IRC( psMember->poArgs );
  psMember->poBody   = poBody; _IRC( psMember->poBody );
  psMember->iArgs    = iArgs;
  psMember->psClass  = psClass;

  _HASV( peMember, psMember );
  _MkcBuildNames( pI, psClass );

  return TCL_OK;

  catch eMemberExists:
    return _MkcError( pI, "Member '%O' already exists", poMember );
  catch eBadUnknownArgs:
    _HADE( peMember );
    return _MkcError( pI, "Special member 'unknown' must have exactly two arguments" );
}

/* _MkcDeleteMember
   simply frees all allocated memory for the given member struct.
*/
static void _MkcDeleteMember( _MkcMember *psMember )
{
  _DRC( psMember->poMember );
  _DRC( psMember->poArgs );
  _DRC( psMember->poBody );

  ckfree( (char*)psMember );
}

/* _MkcDeleteClass
   simply frees all allocated memory for the given class struct.
   also frees all member related storage of that class.
*/
static void _MkcDeleteClass( _MkcClass *psClass )
{
  Tcl_HashEntry  *peMember;
  Tcl_HashSearch  ssMember;
  _MkcMember     *psMember;

  for( _HASCAN( &(psClass->hMembers), peMember, &ssMember ) )
  {
    psMember = (_MkcMember*)_HAGV( peMember );
    if( psMember->psClass == psClass )
      _MkcDeleteMember( psMember );
  }

  _DRC( psClass->poClass );
  Tcl_DeleteHashTable( &(psClass->hInherit) );
  Tcl_DeleteHashTable( &(psClass->hMembers) );

  if( psClass->ppcMembers != NULL )
    ckfree( (char*)psClass->ppcMembers );

  ckfree( (char*)psClass );
}

/* Mkc_ThisCmd
   implements the this command. if poThis in psInfo is NULL, no object's
   member function is currently executed and an error will be returned,
   otherwise the command result will contain poThis.
*/
int Mkc_ThisCmd( ClientData pC, Tcl_Interp *pI, int objc, Tcl_Obj *CONST objv[] )
{
  _MkcInfo   *psInfo = (_MkcInfo*)pC;

  if( psInfo->poThis == NULL )
    return _MkcError( pI, "Not in an object" );
  else
    _SOR( psInfo->poThis );

  return TCL_OK;
}

/* Mkc_ExecCmd
   implements the mkcExec command which is called when an object's member
   function is executed. the arguments are object, member, args. checks if
   the objects exists. checks if the member exists for the object's class.
   if not, the member name might have been abreviated and the char array
   ppcMembers is looked up. if still not found and a member "unknown" exists,
   it is called with the arguments member and args. otherwise an error is
   returned. all elements in args are assigned to the members formal
   parameters. if there are not enough, the default values are assigned.
   if "args" has been defined as the last argument, all remaining arguments
   are assigned to that. if the member is unknown and a member "unknown"
   exists, it is called with the arguments member and args.
*/
int Mkc_ExecCmd( ClientData pC, Tcl_Interp *pI, int objc, Tcl_Obj *CONST objv[] )
{

  _MkcInfo   *psInfo = (_MkcInfo*)pC;

  int         i, iRes, iArgc, iObjc, iValc;
  Tcl_Obj    *poThisOld, **ppoArgv, **ppoObjv, **ppoValv, *poArgs;
  _MkcClass  *psClass;
  _MkcMember *psMember;

  if( objc != 4 )
    return _WNA( 1, "object member args" );

  try( _MkcGetData( pI, &(psInfo->hObjects), _GSO( objv[1] ), &psClass, "Object" ), eError );

  if( _MkcGetData( pI, &(psClass->hMembers), _GSO( objv[2] ), &psMember, "Member" ) != TCL_OK )
  {
    _ROR;
    try( _GIFO( objv[2], psClass->ppcMembers, "member", &i ), eUnknown );
    try( _MkcGetData( pI, &(psClass->hMembers), psClass->ppcMembers[i], &psMember, "Member" ), eUnknown );
  }

  try( _LOGE( objv[3]         , &iValc, &ppoValv ), eError );
  try( _LOGE( psMember->poArgs, &iArgc, &ppoArgv ), eError );

  if( iValc > iArgc && ! psMember->iArgs )
    throw eTooManyValues;

  if( psMember->iArgs ) iArgc--;

  for( i = 0; i < iArgc; i++ )
  {
    try( _LOGE( ppoArgv[i], &iObjc, &ppoObjv ), eError );

    if( i < iValc )
      _OSV( ppoObjv[0], NULL, ppoValv[i] );
    else if( iObjc == 2 )
      _OSV( ppoObjv[0], NULL, ppoObjv[1] );
    else
      throw eNotEnoughValues;
  }

  if ( psMember->iArgs )
  {
    poArgs = _NOB;

    for( i = iArgc; i < iValc; i++ )
      try( _LOAE( poArgs, ppoValv[i] ), eError );

    _OSV( ppoArgv[iArgc], NULL, poArgs );
  }

  poThisOld = psInfo->poThis;
  psInfo->poThis = objv[1];

  iRes = Tcl_EvalObj( pI, psMember->poBody );

  psInfo->poThis = poThisOld;

  return iRes;

  catch eError:
    return TCL_ERROR;
  catch eNotEnoughValues:
    return _MkcError( pI, "Called member %O of object %O with no value for parameter %O", objv[2], objv[1], ppoObjv[0] );
  catch eTooManyValues:
    return _MkcError( pI, "Called member %O of object %O with too many arguments", objv[2], objv[1] );
  catch eUnknown:
    if( _MkcGetData( pI, &(psClass->hMembers), "unknown", &psMember, NULL ) != TCL_OK )
      return TCL_ERROR;

    _LOGE( psMember->poArgs, &iArgc, &ppoArgv );
    _OSV( ppoArgv[0], NULL, objv[2] );
    _OSV( ppoArgv[1], NULL, objv[3] );

    poThisOld = psInfo->poThis;
    psInfo->poThis = objv[1];

    iRes = Tcl_EvalObj( pI, psMember->poBody );

    psInfo->poThis = poThisOld;

    return iRes;
}

/* Mkc_ClassCmd
   implements the class command. splits up the class name and checks if all
   specified superclasses exist. creates an entry and a class struct for it.
   for each superclass all of its members are copied into the new class. all
   original (not inherited) members of the superclass are copied twice: with
   the plain member name (e.g. m1) and with the full name (e.g. MyClass:m1).
   if inherited members are overwritten the full name is still available.
   finally the constructor and destructor is created resp. overwritten
   and the two new commands for creating and deleting objects are created.
*/
int Mkc_ClassCmd( ClientData pC, Tcl_Interp *pI, int objc, Tcl_Obj *CONST objv[] )
{
  _MkcInfo       *psInfo    = (_MkcInfo*)pC;
  Tcl_HashTable  *phClasses = &(psInfo->hClasses);

  int             i, iNew, iObjc;
  char           *pcMember;
  Tcl_Obj        *poClass, *poBuf, **ppoObjv;
  Tcl_HashEntry  *peClass, *peSuper;
  Tcl_HashSearch  ssSuper;
  _MkcClass      *psClass, *psSuper;
  _MkcMember     *psMember;

  if( objc != 5 )
    return _WNA( 1, "class?:superclass:...? args constructor destructor" );

  try( _MkcSplitName( pI, objv[1], &iObjc, &ppoObjv, 0, NULL ), eError );

  for( i = 1; i < iObjc; i++ )
    try( _MkcGetEntry( pI, phClasses, _GSO( ppoObjv[i] ), &peSuper, "Class" ), eError );

  poClass = ppoObjv[0];
  peClass = _HACE( phClasses, _GSO( poClass ), &iNew );
  if( ! iNew )
    throw eClassExists;

  psClass = (_MkcClass*)ckalloc( sizeof(_MkcClass) );
  psClass->poClass    = poClass; _IRC( psClass->poClass );
  psClass->psInfo     = psInfo;
  psClass->ppcMembers = NULL;
  Tcl_InitHashTable( &(psClass->hInherit), TCL_STRING_KEYS );
  Tcl_InitHashTable( &(psClass->hMembers), TCL_STRING_KEYS );
  _HASV( peClass, (ClientData)psClass );

  poBuf = _NOB;
  for( i = 1; i < iObjc; i++ )
  {
    try( _MkcGetData( pI, phClasses, _GSO( ppoObjv[i] ), &psSuper, "Class" ), eError );
    _HAFESV( &(psClass->hInherit), _GSO( ppoObjv[i] ), psSuper, &iNew );

    for( _HASCAN( &(psSuper->hMembers), peSuper, &ssSuper ) )
    {
      psMember = (_MkcMember*)_HAGV( peSuper );
      pcMember = _HAGK( &(psSuper->hMembers), peSuper );

      _HAFESV( &(psClass->hMembers), pcMember, psMember, &iNew );

      if( strchr( pcMember, ':' ) == NULL )
      {
        _SSO( poBuf, "" ); _ASO( poBuf, _GSO( psSuper->poClass ), ":", pcMember, NULL );
        _HAFESV( &(psClass->hMembers), _GSO( poBuf ), psMember, &iNew );
      }
    }
  }

  try( _MkcCreateMember( pI, psClass, _NSO( "+" ), objv[2], objv[3] ), eError );
  try( _MkcCreateMember( pI, psClass, _NSO( "-" ), _NSO( "" ), objv[4] ), eError );

  _SSO( poBuf, "" ); _ASO( poBuf, "~", _GSO( poClass ), NULL );
  Tcl_CreateObjCommand( pI, _GSO( poClass ), Mkc_ConstrCmd, (ClientData)psClass, NULL );
  Tcl_CreateObjCommand( pI, _GSO( poBuf )  , Mkc_DestrCmd , (ClientData)psClass, NULL );

  _DRC( poBuf );

  return TCL_OK;

  catch eError:
    return TCL_ERROR;
  catch eClassExists:
    return _MkcError( pI, "Class '%O' already exists", objv[1] );
}

/* Mkc_ClassDelCmd
   implements the ~class command. if the given class exists it is deleted.
*/
int Mkc_ClassDelCmd( ClientData pC, Tcl_Interp *pI, int objc, Tcl_Obj *CONST objv[] )
{
  _MkcInfo      *psInfo    = (_MkcInfo*)pC;
  Tcl_HashTable *phClasses = &(psInfo->hClasses);

  Tcl_HashEntry *peClass;
  _MkcClass     *psClass;

  if( objc != 2 )
    return _WNA( 1, "class" );

  try( _MkcGetEntry( pI, phClasses, _GSO( objv[1] ), &peClass, "Class" ), eError );
  psClass = (_MkcClass*)_HAGV( peClass );
  try( _MkcObjectsExist( pI, psClass ), eError );

  _MkcDeleteClass( psClass );
  _HADE( peClass );
  _OUVG( objv[1], NULL );

  return TCL_OK;

  catch eError:
    return TCL_ERROR;
}

/* Mkc_MemberCmd
   implements the member command. if the member name is of correct format,
   the class is retrieved and the member is created by storing its name,
   arguments and body.
*/
int Mkc_MemberCmd( ClientData pC, Tcl_Interp *pI, int objc, Tcl_Obj *CONST objv[] )
{
  _MkcInfo      *psInfo    = (_MkcInfo*)pC;
  Tcl_HashTable *phClasses = &(psInfo->hClasses);

  int            iObjc;
  Tcl_Obj      **ppoObjv;
  _MkcClass     *psClass;

  if( objc != 4 )
    return _WNA( 1, "class:member args body" );

  try( _MkcSplitName( pI, objv[1], &iObjc, &ppoObjv, 2, "class:member" ), eError );
  try( _MkcGetData( pI, phClasses, _GSO( ppoObjv[0] ), &psClass, "Class" ), eError );
  try( _MkcCreateMember( pI, psClass, ppoObjv[1], objv[2], objv[3] ), eError );

  return TCL_OK;

  catch eError:
    return TCL_ERROR;
}

/* Mkc_MemberDelCmd
   implements the ~member command. if the format is correct and both class
   and member exist, the member is deleted from the class.
*/
int Mkc_MemberDelCmd( ClientData pC, Tcl_Interp *pI, int objc, Tcl_Obj *CONST objv[] )
{
  _MkcInfo      *psInfo    = (_MkcInfo*)pC;
  Tcl_HashTable *phClasses = &(psInfo->hClasses);

  int            iObjc;
  Tcl_Obj      **ppoObjv;
  Tcl_HashEntry *peMember;
  _MkcClass     *psClass;

  if( objc != 2 )
    return _WNA( 1, "class:member" );

  try( _MkcSplitName( pI, objv[1], &iObjc, &ppoObjv, 2, "class:member" ), eError );
  try( _MkcGetData( pI, phClasses, _GSO( ppoObjv[0] ), &psClass, "Class" ), eError );
  try( _MkcObjectsExist( pI, psClass ), eError );
  try( _MkcGetEntry( pI, &(psClass->hMembers), _GSO( ppoObjv[1] ), &peMember, "Member" ), eError );

  _MkcDeleteMember( (_MkcMember*)_HAGV( peMember ) );
  _HADE( peMember );
  _MkcBuildNames( pI, psClass );

  return TCL_OK;

  catch eError:
    return TCL_ERROR;
}

/* Mkc_ConstrCmd
   implements the command for a class created by the class command. the second
   argument in objv must contain the name of an object to be created. if this
   object does not yet exist, a procedure with the object's name is created
   and the constructor of the object's class is executed.
*/
int Mkc_ConstrCmd( ClientData pC, Tcl_Interp *pI, int objc, Tcl_Obj *CONST objv[] )
{
  _MkcClass     *psClass   = (_MkcClass*)pC;
  Tcl_HashTable *phObjects = &(psClass->psInfo->hObjects);

  int            i, bNew;
  Tcl_Obj       *poObj, *poArgs;
  Tcl_HashEntry *peObj;

  if( objc < 2 )
    return _WNA( 1, "objectName ?args ...?" );

  poObj = objv[1];
  peObj = _HACE( phObjects, _GSO( poObj ), &bNew );
  if( ! bNew )
    throw eObjectExists;

  _HASV( peObj, psClass );

  for( poArgs = _NOB, i = 2; i < objc; i++ )
    try( _LOAE( poArgs, objv[i] ), eError );

  try( Tcl_VarEval( pI, "proc ", _GSO( poObj ), " { method args } { mkcExec ", _GSO( poObj ),
                        " $method $args }; ",_GSO( poObj ), " + ", _GSO( poArgs ), NULL ), eRollback );

  _DRC( poArgs );

  return TCL_OK;

  catch eError:
    return TCL_ERROR;
  catch eObjectExists:
    return _MkcError( pI, "Object '%O' already exists", poObj );
  catch eRollback:
    Tcl_DeleteCommand( pI, _GSO( poObj ) );
    _HADE( peObj );
    _DRC( poArgs );

    return TCL_ERROR;
}

/* Mkc_DestrCmd
   implements the command for the deletion of an object. the second
   argument in objv must contain the name of the object to be deleted. if this
   object exists and is of correct class, its destructor is executed and
   its associated procedure is deleted.
*/
int Mkc_DestrCmd( ClientData pC, Tcl_Interp *pI, int objc, Tcl_Obj *CONST objv[] )
{
  _MkcClass     *psClass   = (_MkcClass*)pC;
  Tcl_HashTable *phObjects = &(psClass->psInfo->hObjects);

  Tcl_HashEntry *peObject;

  if( objc != 2 )
    return _WNA( 1, "objectName" );

  peObject = _HAFE( phObjects, _GSO( objv[1] ) );

  if( peObject == NULL )
    throw eBadObject;
  else if( (_MkcClass*)_HAGV( peObject ) != psClass )
    throw eWrongClass;

  Tcl_VarEval( pI, _GSO( objv[1] ), " - ", NULL );
  Tcl_DeleteCommand( pI, _GSO( objv[1] ) );

  _HADE( peObject );
  _OUVG( objv[1], NULL );

  return TCL_OK;

  catch eBadObject:
    return _MkcError( pI, "Object '%O' does not exist", objv[1] );
  catch eWrongClass:
    return _MkcError( pI, "Object '%O' is not of class '%O'", objv[1], psClass->poClass );
}


/* Mkc_CinfoCmd
   implements the cinfo command. checks if the provided option is valid.
   if so, it searches the different class, member and object tables
   depending on the option and builds the result
*/
int Mkc_CinfoCmd( ClientData pC, Tcl_Interp *pI, int objc, Tcl_Obj *CONST objv[] )
{
  _MkcInfo      *psInfo    = (_MkcInfo*)pC;
  Tcl_HashTable *phClasses = &(psInfo->hClasses);
  Tcl_HashTable *phObjects = &(psInfo->hObjects);

  static char *pArg[] = { "class", "classes", "objects", "members", "isclass", "isobject",
                          "ismember", "superclasses", "body", "args", "version", "dump", NULL };

  enum options { _CLASS, _CLASSES, _OBJECTS, _MEMBERS, _ISCLASS, _ISOBJECT,
                 _ISMEMBER, _SUPERCLASSES, _BODY, _ARGS, _VER, _DUMP };

  int             iOpt, iObjc, i;
  char            pcBuf[10000];
  Tcl_Obj       **ppoObjv, *poResult;
  Tcl_HashEntry  *peClass, *peMember, *peObject;
  Tcl_HashSearch  ssClass, ssMember, ssObject;
  _MkcClass      *psClass;
  _MkcMember     *psMember;

  if( objc < 2 )
    return _WNA( 1, "option ?arg?" );

  try( _GIFO( objv[1], pArg, "option", &iOpt ), eError );

  switch( iOpt )
  {
    case _CLASS:
      if( objc != 3 )
        return _WNA( 2, "object" );

      try( _MkcGetData( pI, phObjects, _GSO( objv[2] ), &psClass, "Object" ), eError );
      _SOR( psClass->poClass );

      break;
    case _CLASSES:
      if( objc != 2 )
        return _WNA( 2, "" );

      for( _HASCAN( phClasses, peClass, &ssClass ) )
        _LOAE( _GOR, _NSO( _HAGK( phClasses, peClass ) ) );

      break;
    case _OBJECTS:
      if( objc > 3 )
        return _WNA( 2, "?class?" );

      if( objc == 3 )
        try( _MkcGetData( pI, phClasses, _GSO( objv[2] ), &psClass, "Class" ), eError );

      for( _HASCAN( phObjects, peObject, &ssObject ) )
        if( objc == 2 || (_MkcClass*)_HAGV( peObject ) == psClass )
          _LOAE( _GOR, _NSO( _HAGK( phObjects, peObject ) ) );

      break;
    case _MEMBERS:
      if( objc != 3 )
        return _WNA( 2, "class" );

      try( _MkcGetData( pI, phClasses, _GSO( objv[2] ), &psClass, "Class" ), eError );

      for( _HASCAN( &(psClass->hMembers), peMember, &ssMember ) )
        if( strchr( _HAGK( &(psClass->hMembers), peMember ), ':' ) == NULL )
          _LOAE( _GOR, _NSO( _HAGK( &(psClass->hMembers), peMember ) ) );

      break;
    case _ISCLASS:
      if( objc != 3 )
        return _WNA( 2, "class" );

      _SIO( _GOR, ( _HAFE( phClasses, _GSO( objv[2] ) ) != NULL ) );

      break;
    case _ISOBJECT:
      if( objc != 3 )
        return _WNA( 2, "object" );

      _SIO( _GOR, ( _HAFE( phObjects, _GSO( objv[2] ) ) != NULL ) );

      break;
    case _ISMEMBER:
      if( objc != 3 )
        return _WNA( 2, "class:member" );

      try( _MkcSplitName( pI, objv[2], &iObjc, &ppoObjv, 2, "class:member" ), eError );
      try( _MkcGetData( pI, phClasses, _GSO( ppoObjv[0] ), &psClass, "Class" ), eError );

      _SIO( _GOR, ( _HAFE( &(psClass->hMembers), _GSO( ppoObjv[1] ) ) != NULL ) );

      break;
    case _SUPERCLASSES:
      if( objc != 3 )
        return _WNA( 2, "class" );

      try( _MkcGetData( pI, phClasses, _GSO( objv[2] ), &psClass, "Class" ), eError );

      for( _HASCAN( &(psClass->hInherit), peClass, &ssClass ) )
        _LOAE( _GOR, _NSO( _HAGK( &(psClass->hInherit), peClass ) ) );

      break;
    case _BODY:
    case _ARGS:
      if( objc != 3 )
        return _WNA( 2, "class:member" );

      try( _MkcSplitName( pI, objv[2], &iObjc, &ppoObjv, 2, "class:member" ), eError );
      try( _MkcGetData( pI, phClasses, _GSO( ppoObjv[0] ), &psClass, "Class" ), eError );
      try( _MkcGetData( pI, &(psClass->hMembers), _GSO( ppoObjv[1] ), &psMember, "Member" ), eError );

      _LOAL( _GOR, ( iOpt==8 )? psMember->poBody : psMember->poArgs );

      break;
    case _VER:
      if( objc != 2 )
        return _WNA( 2, "" );

      _SSO( _GOR, _VERSION );

      break;
    case _DUMP:
      if( objc < 2 || objc > 3 )
        return _WNA( 2, "?class?" );

      for( i = 0, _HASCAN( phClasses, peClass, &ssClass ), i++ );
      sprintf( pcBuf, "Classes: %d total\n", i );
      poResult = _NSO( pcBuf );

      for( _HASCAN( phClasses, peClass, &ssClass ) )
      {
        psClass = (_MkcClass*)_HAGV( peClass );

        if( objc == 3 && strcmp( _GSO( objv[2] ), _GSO( psClass->poClass ) ) )
          continue;

        sprintf( pcBuf, "  Class %s:\n", _GSO( psClass->poClass ) );
        _ASO( poResult, pcBuf, NULL );

        for( i = 0, _HASCAN( &(psClass->hInherit), peMember, &ssMember ), i++ );
        sprintf( pcBuf, "    Superclasses: %d\n", i );
        _ASO( poResult, pcBuf, NULL );

        for( _HASCAN( &(psClass->hInherit), peMember, &ssMember ) )
        {
          sprintf( pcBuf, "      Superclass %s\n", _HAGK( &(psClass->hInherit), peMember ) );
          _ASO( poResult, pcBuf, NULL );
        }

        for( i = 0, _HASCAN( &(psClass->hMembers), peMember, &ssMember ), i++ );
        sprintf( pcBuf, "    Members: %d\n", i );
        _ASO( poResult, pcBuf, NULL );

        for( _HASCAN( &(psClass->hMembers), peMember, &ssMember ) )
        {
          psMember = (_MkcMember*)_HAGV( peMember );
          sprintf( pcBuf, "      Member %s {%s}  -> %s\n", _HAGK( &(psClass->hMembers), peMember ),
            _GSO( psMember->poArgs ), _GSO( psMember->poMember ) );
          _ASO( poResult, pcBuf, NULL );
        }
      }

      for( i = 0, _HASCAN( phObjects, peObject, &ssObject ), i++ );
      sprintf( pcBuf, "Objects: %d total\n", i );
      _ASO( poResult, pcBuf, NULL );

      for( _HASCAN( phObjects, peObject, &ssObject ) )
      {
        psClass = (_MkcClass*)_HAGV( peObject );
        if( objc == 3 && strcmp( _GSO( objv[2] ), _GSO( psClass->poClass ) ) )
          continue;

        sprintf( pcBuf, "  Object %s  -> %s\n", _HAGK( phObjects, peObject ), _GSO( psClass->poClass ) );
        _ASO( poResult, pcBuf, NULL );
      }

      _SOR( poResult );
  }

  return TCL_OK;

  catch eError:
    return TCL_ERROR;
}

/* Mkc_ThrowCmd
   implements the throw command. retrieves the object name and its class name
   and stores it with the given error text in the result string. always
   returns TCL_ERROR.
*/
int Mkc_ThrowCmd( ClientData pC, Tcl_Interp *pI, int objc, Tcl_Obj *CONST objv[] )
{
  _MkcInfo  *psInfo  = (_MkcInfo*)pC;
  Tcl_Obj   *poThis  = psInfo->poThis;

  _MkcClass *psClass;

  if( objc < 2 || objc > 4 )
    return _WNA( 1, "message ?errorInfo? ?errorCode?" );

  _CHECKTHIS( poThis );
  try( _MkcGetData( pI, &(psInfo->hObjects), _GSO( poThis ), &psClass, "Object" ), eError );

  _ASO( _GOR, _GSO( psClass->poClass ), " ", _GSO( poThis ), ": ", _GSO( objv[1] ), NULL );

  if( objc >= 3 )
    Tcl_AddObjErrorInfo( pI, _GSO( objv[2] ), -1 );

  if( objc == 4 )
    Tcl_SetObjErrorCode( pI, objv[3] );

  return TCL_ERROR;

  catch eError:
    return TCL_ERROR;
}

/* Mkc_MyCmd
   implements the my command. if the object variable in the first argument
   exists, either stores or retrieves the value by manipulating the global
   array that is of the same name as the object.
*/
int Mkc_MyCmd( ClientData pC, Tcl_Interp *pI, int objc, Tcl_Obj *CONST objv[] )
{
  _MkcInfo *psInfo = (_MkcInfo*)pC;
  Tcl_Obj  *poThis = psInfo->poThis;

  Tcl_Obj  *poValue;

  _CHECKTHIS( poThis );

  if( objc == 2 )
  {
    poValue = _OGVG( poThis, objv[1] );
    if( poValue == NULL )
      throw eBadVariable;
  }
  else
  {
    poValue = _OSVG( poThis, objv[1], objv[2] );
    if( poValue == NULL )
      throw eError;
  }

  _SOR( poValue );

  return TCL_OK;

  catch eError:
    return TCL_ERROR;
  catch eBadVariable:
    return _MkcError( pI, "No such object variable '%O'", objv[1] );
}


/* Mkc_UnmyCmd
   implements the unmy command. deletes all object variables given in the
   argument list by deleting the related index of the object's global array.
*/
int Mkc_UnmyCmd( ClientData pC, Tcl_Interp *pI, int objc, Tcl_Obj *CONST objv[] )
{
  _MkcInfo *psInfo = (_MkcInfo*)pC;
  Tcl_Obj  *poThis = psInfo->poThis;

  int i;

  if( objc < 1 )
    return _WNA( 1, "?varName ...?" );

  _CHECKTHIS( poThis );

  for( i = 1; i < objc; i++ )
    _OUVG( poThis, objv[i] );

  return TCL_OK;
}

/* Mkc_MineCmd
   implements the mine command. returns all object variables, eventually
   matching a pattern. lets the array command do the real job.
*/
int Mkc_MineCmd( ClientData pC, Tcl_Interp *pI, int objc, Tcl_Obj *CONST objv[] )
{
  _MkcInfo *psInfo = (_MkcInfo*)pC;
  Tcl_Obj  *poThis = psInfo->poThis;

  Tcl_Obj  *poCmd;

  if( objc > 2 )
    return _WNA( 1, "?pattern?" );

  _CHECKTHIS( poThis );

  poCmd = _NSO( "array names " ); _IRC( poCmd );
  _ASO( poCmd, _GSO( poThis ), " ", ( objc == 1 )? "":_GSO( objv[1] ), NULL );

  try( Tcl_GlobalEvalObj( pI, poCmd ), eError );
  _DRC( poCmd );

  return TCL_OK;

  catch eError:
    return TCL_ERROR;
}

/* Mkc_IsmineCmd
   implements the ismine command. returns 0 or 1, depending on if the object
   variable in the first argument exists.
*/
int Mkc_IsmineCmd( ClientData pC, Tcl_Interp *pI, int objc, Tcl_Obj *CONST objv[] )
{
  _MkcInfo *psInfo = (_MkcInfo*)pC;
  Tcl_Obj  *poThis = psInfo->poThis;

  if( objc != 2 )
    return _WNA( 1, "varName" );

  _CHECKTHIS( poThis );

  if( _OGVG( poThis, objv[1] ) == NULL )
    _SIO( _GOR, 0 );
  else
    _SIO( _GOR, 1 );

  return TCL_OK;
}

/* Mkc_OurCmd
   implements the our command. if the class variable in the first argument
   exists, either stores or retrieves the value by manipulating the global
   array that is of the same name as the object's class.
*/
int Mkc_OurCmd( ClientData pC, Tcl_Interp *pI, int objc, Tcl_Obj *CONST objv[] )
{
  _MkcInfo  *psInfo = (_MkcInfo*)pC;
  Tcl_Obj   *poThis = psInfo->poThis;

  Tcl_Obj   *poValue;
  _MkcClass *psClass;

  if( objc < 2 || objc > 3 )
    return _WNA( 1, "varName ?newValue?" );

  _CHECKTHIS( poThis );
  try( _MkcGetData( pI, &(psInfo->hObjects), _GSO( poThis ), &psClass, "Object" ), eError );

  if( objc == 2 )
  {
    poValue = _OGVG( psClass->poClass, objv[1] );
    if( poValue == NULL )
      throw eBadVariable;
  }
  else
  {
    poValue = _OSVG( psClass->poClass, objv[1], objv[2] );
    if( poValue == NULL )
      throw eError;
  }

  _SOR( poValue );

  return TCL_OK;

  catch eError:
    return TCL_ERROR;
  catch eBadVariable:
    return _MkcError( pI, "No such class variable '%O'", objv[1] );
}

/* Mkc_UnourCmd
   implements the unour command. deletes all class variables given in the
   argument list by deleting the related index of the global array.
*/
int Mkc_UnourCmd( ClientData pC, Tcl_Interp *pI, int objc, Tcl_Obj *CONST objv[] )
{
  _MkcInfo  *psInfo = (_MkcInfo*)pC;
  Tcl_Obj   *poThis = psInfo->poThis;

  int        i;
  _MkcClass *psClass;

  _CHECKTHIS( poThis );
  try( _MkcGetData( pI, &(psInfo->hObjects), _GSO( poThis ), &psClass, "Object" ), eError );

  if( objc < 2 )
    return _WNA( 1, "?varName ...?" );

  for( i = 1; i < objc; i++ )
    _OUVG( psClass->poClass, objv[i] );

  return TCL_OK;

  catch eError:
    return TCL_ERROR;
}

/* Mkc_OursCmd
   implements the ours command. returns all class variables, eventually
   matching a pattern. lets the array command do the real job.
*/
int Mkc_OursCmd( ClientData pC, Tcl_Interp *pI, int objc, Tcl_Obj *CONST objv[] )
{
  _MkcInfo  *psInfo = (_MkcInfo*)pC;
  Tcl_Obj   *poThis = psInfo->poThis;

  Tcl_Obj   *poCmd;
  _MkcClass *psClass;

  if( objc > 2 )
    return _WNA( 1, "?pattern?" );

  _CHECKTHIS( poThis );
  try( _MkcGetData( pI, &(psInfo->hObjects), _GSO( poThis ), &psClass, "Object" ), eError );

  poCmd = _NSO( "array names " ); _IRC( poCmd );
  _ASO( poCmd, _GSO( psClass->poClass ), " ", ( objc == 1 )? "":_GSO( objv[1] ), NULL );

  try( Tcl_GlobalEvalObj( pI, poCmd ), eError );
  _DRC( poCmd );

  return TCL_OK;

  catch eError:
    return TCL_ERROR;
}

/* Mkc_IsoursCmd
   implements the isours command. returns 0 or 1, depending on if the class
   variable in the first argument exists.
*/
int Mkc_IsoursCmd( ClientData pC, Tcl_Interp *pI, int objc, Tcl_Obj *CONST objv[] )
{
  _MkcInfo  *psInfo = (_MkcInfo*)pC;
  Tcl_Obj   *poThis = psInfo->poThis;

  _MkcClass *psClass;

  if( objc != 2 )
    return _WNA( 1, "varName" );

  _CHECKTHIS( poThis );
  try( _MkcGetData( pI, &(psInfo->hObjects), _GSO( poThis ), &psClass, "Object" ), eError );

  if( _OGVG( psClass->poClass, objv[1] ) == NULL )
    _SIO( _GOR, 0 );
  else
    _SIO( _GOR, 1 );

  return TCL_OK;

  catch eError:
    return TCL_ERROR;
}

/* Mkc_MyincrCmd
   implements the myincr command. see the documentation for that command.
*/
int Mkc_MyincrCmd( ClientData pC, Tcl_Interp *pI, int objc, Tcl_Obj *CONST objv[] )
{
  _MkcInfo *psInfo = (_MkcInfo*)pC;
  Tcl_Obj  *poThis = psInfo->poThis;

  int       iValue, iIncr;
  Tcl_Obj  *poValue;

  if( objc < 2 || objc > 3 )
    return _WNA( 1, "varName ?value?" );

  _CHECKTHIS( poThis );

  if( objc == 2 )
    iIncr = 1;
  else
    try( _GIO( objv[2], &iIncr ), eError );

  try( _MkcGetValue( pI, poThis, objv[1], &poValue, 0 ), eError );
  try( _GIO( poValue, &iValue ), eError );
  poValue = _SOB( poValue );

  _SIO( poValue, iValue+iIncr );

  poValue = _OSVG( poThis, objv[1], poValue );
  if( poValue == NULL )
    throw eNotSet;

  _SOR( poValue );

  return TCL_OK;

  catch eError:
    return TCL_ERROR;
  catch eNotSet:
    return _MkcError( pI, "Could not set private variable '%O'", poThis );
}

/* Mkc_MyindexCmd
   implements the myindex command. see the documentation for that command.
*/
int Mkc_MyindexCmd( ClientData pC, Tcl_Interp *pI, int objc, Tcl_Obj *CONST objv[] )
{
  _MkcInfo *psInfo = (_MkcInfo*)pC;
  Tcl_Obj  *poThis = psInfo->poThis;

  int       iObjc, iIndex;
  Tcl_Obj  *poValue, **ppoObjv;

  if( objc != 3 )
    return _WNA( 1, "varName index" );

  _CHECKTHIS( poThis );

  try( _MkcGetValue( pI, poThis, objv[1], &poValue, 0 ), eError );
  try( _LOGE( poValue, &iObjc, &ppoObjv ), eError );

  if( iObjc )
  {
    try( _MkcGetIndex( pI, objv[2], iObjc, &iIndex ), eError );
    if( iIndex >= 0 && iIndex < iObjc )
      _SOR( ppoObjv[iIndex] );
  }

  return TCL_OK;

  catch eError:
    return TCL_ERROR;
}

/* Mkc_MylengthCmd
   implements the mylength command. see the documentation for that command.
*/
int Mkc_MylengthCmd( ClientData pC, Tcl_Interp *pI, int objc, Tcl_Obj *CONST objv[] )
{
  _MkcInfo *psInfo = (_MkcInfo*)pC;
  Tcl_Obj  *poThis = psInfo->poThis;

  int       iLen;
  Tcl_Obj  *poValue;

  if( objc != 2 )
    return _WNA( 1, "varName" );

  _CHECKTHIS( poThis );

  try( _MkcGetValue( pI, poThis, objv[1], &poValue, 0 ), eError );
  try( _LOGL( poValue, &iLen ), eError );

  _SIO( _GOR, iLen );

  return TCL_OK;

  catch eError:
    return TCL_ERROR;
}

/* Mkc_MysearchCmd
   implements the mysearch command. see the documentation for that command.
*/
int Mkc_MysearchCmd( ClientData pC, Tcl_Interp *pI, int objc, Tcl_Obj *CONST objv[] )
{
  _MkcInfo *psInfo = (_MkcInfo*)pC;
  Tcl_Obj  *poThis = psInfo->poThis;

  int       i, iObjc, iMode, iRet;
  Tcl_Obj  *poValue, *poPattern, **ppoObjv;

  static char *pArg[] = { "-exact", "-glob", "-regexp", NULL };

  if( objc < 3 || objc > 4 )
    return _WNA( 1, "?mode? varName pattern" );

  if( objc == 3 )
    iMode = 1;
  else
    try( _GIFO( objv[1], pArg, "mode", &iMode ), eError );

  _CHECKTHIS( poThis );

  poPattern = objv[objc-1];
  try( _MkcGetValue( pI, poThis, objv[objc-2], &poValue, 1 ), eError );
  try( _LOGE( poValue, &iObjc, &ppoObjv ), eError );

  if( iMode == 0 )
  {
    for( i = 0; i < iObjc; i++ )
      if( ! strcmp( _GSO( ppoObjv[i] ), _GSO( poPattern ) ) )
        break;
  }
  else if( iMode == 1 )
  {
    for( i = 0; i < iObjc; i++ )
      if( Tcl_StringMatch( _GSO( ppoObjv[i] ), _GSO( poPattern ) ) )
        break;
  }
  else
  {
    for( i = 0; i < iObjc; i++ )
      if( iRet = Tcl_RegExpMatch( pI, _GSO( ppoObjv[i] ), _GSO( poPattern ) ) )
        break;

    if( iRet == -1 )
      throw eError;
  }

  if( i == iObjc )
    _SIO( _GOR, -1 );
  else
    _SIO( _GOR, i );

  return TCL_OK;

  catch eError:
    return TCL_ERROR;
}

/* Mkc_MyconcatCmd
   implements the myconcat command. see the documentation for that command.
*/
int Mkc_MyconcatCmd( ClientData pC, Tcl_Interp *pI, int objc, Tcl_Obj *CONST objv[] )
{
  _MkcInfo *psInfo = (_MkcInfo*)pC;
  Tcl_Obj  *poThis = psInfo->poThis;

  Tcl_Obj  *poValue;

  if( objc < 2 )
    return _WNA( 1, "varName ?value ...?" );

  _CHECKTHIS( poThis );

  _MkcGetValue( pI, poThis, objv[1], &poValue, 1 );
  poValue = _SOB( poValue );

  try( _LOAL( poValue, Tcl_ConcatObj( objc-2, &(objv[2]) ) ), eError );

  _OSVG( poThis, objv[1], poValue );
  _SOR( poValue );

  return TCL_OK;

  catch eError:
    return TCL_ERROR;
}

/* Mkc_MyappendCmd
   implements the myappend command. see the documentation for that command.
*/
int Mkc_MyappendCmd( ClientData pC, Tcl_Interp *pI, int objc, Tcl_Obj *CONST objv[] )
{
  _MkcInfo *psInfo = (_MkcInfo*)pC;
  Tcl_Obj  *poThis = psInfo->poThis;

  int       i;
  Tcl_Obj  *poValue;

  if( objc < 2 )
    return _WNA( 1, "varName ?value ...?" );

  _CHECKTHIS( poThis );

  try( _MkcGetValue( pI, poThis, objv[1], &poValue, 1 ), eError );
  poValue = _SOB( poValue );

  for( i = 2; i < objc; i++ )
    try( _LOAE( poValue, objv[i] ), eError );

  _OSVG( poThis, objv[1], poValue );
  _SOR( poValue );

  return TCL_OK;

  catch eError:
    return TCL_ERROR;
}

/* Mkc_MyrangeCmd
   implements the myrange command. see the documentation for that command.
*/
int Mkc_MyrangeCmd( ClientData pC, Tcl_Interp *pI, int objc, Tcl_Obj *CONST objv[] )
{
  _MkcInfo *psInfo = (_MkcInfo*)pC;
  Tcl_Obj  *poThis = psInfo->poThis;

  int       iObjc, iFrom, iTo;
  Tcl_Obj  *poValue, **ppoObjv;

  if( objc != 4 )
    return _WNA( 1, "varName first last" );

  _CHECKTHIS( poThis );

  try( _MkcGetValue( pI, poThis, objv[1], &poValue, 0 ), eError );
  try( _LOGE( poValue, &iObjc, &ppoObjv ), eError );
  try( _MkcGetIndex( pI, objv[2], iObjc, &iFrom ), eError );
  try( _MkcGetIndex( pI, objv[3], iObjc, &iTo   ), eError );

  if( ! ( ( iFrom < 0 && iTo < 0 ) || ( iFrom >= iObjc && iTo >= iObjc ) || iFrom > iTo ) )
  {
    iFrom = (iFrom < 0)? 0 : iFrom;
    iTo   = (iTo >= iObjc)? iObjc-1 : iTo;
    _SOR( Tcl_NewListObj( iTo-iFrom+1, &ppoObjv[iFrom] ) );
  }

  return TCL_OK;

  catch eError:
    return TCL_ERROR;
}

/* Mkc_MydeleteCmd
   implements the mydelete command. see the documentation for that command.
*/
int Mkc_MydeleteCmd( ClientData pC, Tcl_Interp *pI, int objc, Tcl_Obj *CONST objv[] )
{
  _MkcInfo *psInfo = (_MkcInfo*)pC;
  Tcl_Obj  *poThis = psInfo->poThis;

  int       i, iLen, *piIndexes;
  Tcl_Obj  *poValue;

  if( objc < 2 )
    return _WNA( 1, "varName ?index ...?" );

  _CHECKTHIS( poThis );

  try( _MkcGetValue( pI, poThis, objv[1], &poValue, 1 ), eError );
  try( _LOGL( poValue, &iLen ), eError );
  poValue = _SOB( poValue );
  piIndexes = (int*)ckalloc( (objc-2) * sizeof(int) );

  for( i = 2; i < objc; i++ )
    try( _MkcGetIndex( pI, objv[i], iLen, piIndexes+i-2 ), eError );

  qsort( piIndexes, objc-2, sizeof(int), _MkcCompareInt );

  for( i = objc-3; i >= 0; i-- )
  {
    if( piIndexes[i] == piIndexes[i-1] && i > 0 )
      continue;

    if( piIndexes[i] >= 0 && piIndexes[i] < iLen )
      _LODE( poValue, piIndexes[i] );
  }

  ckfree( (char*)piIndexes );

  _OSVG( poThis, objv[1], poValue );

  return TCL_OK;

  catch eError:
    return TCL_ERROR;
}

/* Mkc_MyinsertCmd
   implements the myinsert command. see the documentation for that command.
*/
int Mkc_MyinsertCmd( ClientData pC, Tcl_Interp *pI, int objc, Tcl_Obj *CONST objv[] )
{
  _MkcInfo *psInfo = (_MkcInfo*)pC;
  Tcl_Obj  *poThis = psInfo->poThis;

  int       iIndex, iLen;
  Tcl_Obj  *poValue;

  if( objc < 3 )
    return _WNA( 1, "varName index ?element ...?" );

  _CHECKTHIS( poThis );

  try( _MkcGetValue( pI, poThis, objv[1], &poValue, 1 ), eError );
  try( _LOGL( poValue, &iLen ), eError );

  if( ! strcmp( _GSO( objv[2] ), "end" ) )
    iIndex = iLen;
  else
    try( _MkcGetIndex( pI, objv[2], iLen, &iIndex ), eError );

  poValue = _SOB( poValue );
  try( _LOIR( poValue, iIndex, objc-3, &objv[3] ), eError );

  _OSVG( poThis, objv[1], poValue );

  return TCL_OK;

  catch eError:
    return TCL_ERROR;
}

/* Mkc_MyreplaceCmd
   implements the myreplace command. see the documentation for that command.
*/
int Mkc_MyreplaceCmd( ClientData pC, Tcl_Interp *pI, int objc, Tcl_Obj *CONST objv[] )
{
  _MkcInfo *psInfo = (_MkcInfo*)pC;
  Tcl_Obj  *poThis = psInfo->poThis;

  int       iLen, iFrom, iTo, iCount;
  Tcl_Obj  *poValue;

  if( objc < 4 )
    return _WNA( 1, "varName first last ?element ...?" );

  _CHECKTHIS( poThis );

  try( _MkcGetValue( pI, poThis, objv[1], &poValue, 1 ), eError );
  try( _LOGL( poValue, &iLen ), eError );
  try( _MkcGetIndex( pI, objv[2], iLen, &iFrom ), eError );
  try( _MkcGetIndex( pI, objv[3], iLen, &iTo   ), eError );

  if( iFrom < 0 )
    iFrom = 0;

  iCount = iTo-iFrom+1;
  if( iCount > iLen-iFrom )
    iCount = iLen-iFrom;

  poValue = _SOB( poValue );
  Tcl_ListObjReplace( pI, poValue, iFrom, iCount, objc-4, &objv[4] );

  _OSVG( poThis, objv[1], poValue );

  return TCL_OK;

  catch eError:
    return TCL_ERROR;
}

/* Mkc_MyassignCmd
   implements the myassign command. see the documentation for that command.
*/
int Mkc_MyassignCmd( ClientData pC, Tcl_Interp *pI, int objc, Tcl_Obj *CONST objv[] )
{
  _MkcInfo *psInfo = (_MkcInfo*)pC;
  Tcl_Obj  *poThis = psInfo->poThis;

  int       i, iObjc, iMax;
  Tcl_Obj **ppoObjv;

  if( objc < 2 )
    return _WNA( 1, "list ?varName ...?" );

  _CHECKTHIS( poThis );

  try( _LOGE( objv[1], &iObjc, &ppoObjv ), eError );
  iMax = ( iObjc < objc-2 )? iObjc : objc-2;

  for( i = 0; i < iMax; i++ )
    _OSVG( poThis, objv[i+2], ppoObjv[i] );

  return TCL_OK;

  catch eError:
    return TCL_ERROR;
}

/* Mkc_MylistCmd
   implements the mylist command. see the documentation for that command.
*/
int Mkc_MylistCmd( ClientData pC, Tcl_Interp *pI, int objc, Tcl_Obj *CONST objv[] )
{
  _MkcInfo *psInfo = (_MkcInfo*)pC;
  Tcl_Obj  *poThis = psInfo->poThis;

  int       i;
  Tcl_Obj  *poValue;

  if( objc < 2 )
    return _WNA( 1, "?varName ...?" );

  _CHECKTHIS( poThis );

  for( i = 1; i < objc; i++ )
  {
    try( _MkcGetValue( pI, poThis, objv[i], &poValue, 0 ), eError );
    poValue = _SOB( poValue );
    _LOAE( _GOR, poValue );
  }

  return TCL_OK;

  catch eError:
    return TCL_ERROR;
}

/* Mkclasses_Init
   package initialization. allocates an info structure and initializes the
   class and object table. defines a procedure to call when the interpreter
   is deleted. finally creates all new commands and registers the package.
*/
int Mkclasses_Init( Tcl_Interp *pI )
{
  _MkcInfo *psInfo;
  ClientData pC;

#ifdef USE_TCL_STUBS
  if( Tcl_InitStubs( pI, "8.2", 0) == NULL )
    throw eError;
#endif

  if( TCL_MAJOR_VERSION < 8 )
    throw eWrongVersion;

  psInfo = (_MkcInfo*)ckalloc( sizeof(_MkcInfo) );
  Tcl_InitHashTable( &(psInfo->hClasses), TCL_STRING_KEYS );
  Tcl_InitHashTable( &(psInfo->hObjects), TCL_STRING_KEYS );
  psInfo->poThis = NULL;

  pC = (ClientData)psInfo;
  Tcl_CallWhenDeleted( pI, Mkclasses_Exit, pC );

  Tcl_CreateObjCommand( pI, "mkcExec" , Mkc_ExecCmd     , pC, NULL );
  Tcl_CreateObjCommand( pI, "this"    , Mkc_ThisCmd     , pC, NULL );
  Tcl_CreateObjCommand( pI, "cinfo"   , Mkc_CinfoCmd    , pC, NULL );
  Tcl_CreateObjCommand( pI, "throw"   , Mkc_ThrowCmd    , pC, NULL );

  Tcl_CreateObjCommand( pI, "class"   , Mkc_ClassCmd    , pC, NULL );
  Tcl_CreateObjCommand( pI, "~class"  , Mkc_ClassDelCmd , pC, NULL );
  Tcl_CreateObjCommand( pI, "member"  , Mkc_MemberCmd   , pC, NULL );
  Tcl_CreateObjCommand( pI, "~member" , Mkc_MemberDelCmd, pC, NULL );

  Tcl_CreateObjCommand( pI, "my"      , Mkc_MyCmd       , pC, NULL );
  Tcl_CreateObjCommand( pI, "unmy"    , Mkc_UnmyCmd     , pC, NULL );
  Tcl_CreateObjCommand( pI, "mine"    , Mkc_MineCmd     , pC, NULL );
  Tcl_CreateObjCommand( pI, "ismine"  , Mkc_IsmineCmd   , pC, NULL );

  Tcl_CreateObjCommand( pI, "our"     , Mkc_OurCmd      , pC, NULL );
  Tcl_CreateObjCommand( pI, "unour"   , Mkc_UnourCmd    , pC, NULL );
  Tcl_CreateObjCommand( pI, "ours"    , Mkc_OursCmd     , pC, NULL );
  Tcl_CreateObjCommand( pI, "isours"  , Mkc_IsoursCmd   , pC, NULL );

  Tcl_CreateObjCommand( pI, "myincr"  , Mkc_MyincrCmd   , pC, NULL );
  Tcl_CreateObjCommand( pI, "myindex" , Mkc_MyindexCmd  , pC, NULL );
  Tcl_CreateObjCommand( pI, "mylength", Mkc_MylengthCmd , pC, NULL );
  Tcl_CreateObjCommand( pI, "mysearch", Mkc_MysearchCmd , pC, NULL );
  Tcl_CreateObjCommand( pI, "myconcat", Mkc_MyconcatCmd , pC, NULL );
  Tcl_CreateObjCommand( pI, "myappend", Mkc_MyappendCmd , pC, NULL );
  Tcl_CreateObjCommand( pI, "myrange" , Mkc_MyrangeCmd  , pC, NULL );
  Tcl_CreateObjCommand( pI, "mydelete", Mkc_MydeleteCmd , pC, NULL );
  Tcl_CreateObjCommand( pI, "myinsert", Mkc_MyinsertCmd , pC, NULL );
  Tcl_CreateObjCommand( pI, "myreplace",Mkc_MyreplaceCmd, pC, NULL );
  Tcl_CreateObjCommand( pI, "myassign", Mkc_MyassignCmd , pC, NULL );
  Tcl_CreateObjCommand( pI, "mylist"  , Mkc_MylistCmd   , pC, NULL );

  try( Tcl_PkgProvide( pI, "mkClasses", _VERSION ), eError );

  return TCL_OK;

  catch eError:
    return TCL_ERROR;
  catch eWrongVersion:
    return _MkcError( pI, "Package mkClasses requires Tcl Version 8" );
}

int Mkclasses_SafeInit( Tcl_Interp *pI )
{
  return Mkclasses_Init( pI );
}

/* Mkclasses_Exit
   termination procedure. called when the interpreter is deleted. frees up
   any memory previously allocated in the member, class and object tables.
   finally frees the info struct.
*/
void Mkclasses_Exit( ClientData pC, Tcl_Interp *pI )
{
  _MkcInfo *psInfo = (_MkcInfo*)pC;

  Tcl_HashEntry *peClass;
  Tcl_HashSearch ssClass;

  for( _HASCAN( &(psInfo->hClasses), peClass, &ssClass ) )
    _MkcDeleteClass( (_MkcClass*)_HAGV( peClass ) );

  Tcl_DeleteHashTable( &(psInfo->hClasses) );
  Tcl_DeleteHashTable( &(psInfo->hObjects) );

  ckfree( (char*)psInfo );
}

/* static linking. uncomment the following two functions if you want
   to create a stand-alone shell instead of a dynamic library. */

#ifndef USE_TCL_STUBS
int main( int argc, char *argv[] )
{
  Tcl_Main( argc, argv, Tcl_AppInit );
  return 0;
}

int Tcl_AppInit( Tcl_Interp *pI )
{
  try( Tcl_Init( pI ), eError );
  try( Mkclasses_Init( pI ), eError );

  return TCL_OK;

  catch eError:
    return TCL_ERROR;
}
#endif

/*
 * mkClasses 1.0
 * -------------
 */
